ClassFile.StackMapsOption (Java SE 23 & JDK 23)
Description: declaration: module: java.base, package: java.lang.classfile, interface: ClassFile, enum: StackMapsOption
Keywords: java.lang.classfile.ClassFile.StackMapsOption class

# Enum Class ClassFile.StackMapsOption

java.lang.Object
java.lang.Enum<ClassFile.StackMapsOptionPREVIEW>
java.lang.classfile.ClassFile.StackMapsOption

All Implemented Interfaces:
  `Serializable`, `ClassFile.OptionPREVIEW`, `Comparable<ClassFile.StackMapsOptionPREVIEW>`, `Constable`

Enclosing interface:
  `ClassFilePREVIEW`

public static enum ClassFile.StackMapsOption extends Enum<ClassFile.StackMapsOptionPREVIEW> implements ClassFile.OptionPREVIEW
`StackMapsOption` is a preview API of the Java platform.
Programs can only use `StackMapsOption` when preview features are enabled.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
Option describing whether to generate stackmaps. Default is `STACK_MAPS_WHEN_REQUIRED` to generate stack maps for `ClassFile.JAVA_6_VERSION`PREVIEW or above, where specifically for `ClassFile.JAVA_6_VERSION`PREVIEW the stack maps may not be generated.

See Java Virtual Machine Specification:
  4.10.1 Verification by Type Checking
Since:
  22

- ## Nested Class Summary

  ### Nested classes/interfaces declared in class java.lang.Enum

  `Enum.EnumDesc<E extends Enum<E>>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `DROP_STACK_MAPS`
  Drop stack maps from code
  `GENERATE_STACK_MAPS`
  Always generate stack maps
  `STACK_MAPS_WHEN_REQUIRED`
  Generate stack maps when required

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static ClassFile.StackMapsOptionPREVIEW`
  `valueOf(String name)`
  Returns the enum constant of this class with the specified name.
  `static ClassFile.StackMapsOptionPREVIEW[]`
  `values()`
  Returns an array containing the constants of this enum class, in the order they are declared.

  ### Methods declared in class java.lang.Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods declared in class java.lang.Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### STACK_MAPS_WHEN_REQUIRED

    public static final ClassFile.StackMapsOptionPREVIEW STACK_MAPS_WHEN_REQUIRED
    Generate stack maps when required

  - ### GENERATE_STACK_MAPS

    public static final ClassFile.StackMapsOptionPREVIEW GENERATE_STACK_MAPS
    Always generate stack maps

  - ### DROP_STACK_MAPS

    public static final ClassFile.StackMapsOptionPREVIEW DROP_STACK_MAPS
    Drop stack maps from code

- ## Method Details

  - ### values

    public static ClassFile.StackMapsOptionPREVIEW[] values()
    Returns an array containing the constants of this enum class, in the order they are declared.
    Returns:
      an array containing the constants of this enum class, in the order they are declared

  - ### valueOf

    public static ClassFile.StackMapsOptionPREVIEW valueOf(String name)
    Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum class has no constant with the specified name
      `NullPointerException` - if the argument is null